\section{Acceptance Testing}
Professional programmers need to make sure that they communicate accurate and right in order to create valuable software.

\subsection{Communication Requirements}
Software developers need to make sure that the business requirements are transported into the development team.

\paragraph{Premature Precision}
Developers and the business often want to know with the highest precision what they get before the project. This precision can often not be achieved.

\paragraph{The Uncertainity Principle}
Is the problem that the system appears different finished than specified on the paper. When the business sees the running system they realize that they don't need what they have specified.

\paragraph{Estimation Anxiety}
Professional developers understand that estimates can, and should, be made based on low precision requirements and realize that those estimates are estimates.

\subsection{Acceptance Tests}
Acceptance test are not defined clearly,  in this chapter we define it as: tests that are defined by a collaboration of the stakeholders and the progamers.

\paragraph{The Definition of Done}
Make sure that the team of developers has a common meaning on when something is done. Otherwise the management of the project can be very tricky.

\paragraph{Communication}
The goal of having acceptance tests is to have clear communication what the requirements of the business are.

\paragraph{Automation}
The acceptance test should always be automated. The reason for this requirement is simple: cost!

\paragraph{Who Writes Acceptance Tests, and When?}
In the ideal world we imagine the stakeholders and the QA team would write the tests and the developers would review them. These test should be written as late as possible to take care of the "late precision" effect.

\paragraph{Test Negotiation and Passive Aggression}
Tests authors are also only human and sometimes the written test don't make a lot of sense. Therefore it's your responsibility as a developer to improve these test with the specifier.

\paragraph{Acceptance Tests and Unit Tests}
Acceptance Tests are not Unit Tests! Unit Test are from programmers for programers, while Acceptance Tests are written by the business for the business. Acceptance Tests and Unit Tests may even test the same thing but they are not the same!

\paragraph{Continuous Integration}
Make sure all the unit tests and integration tests are automated each time you check in your code.


